Sha256: b9d2f6f2d76001b23f21ef418aa69d75ee5d68102c70732ccca41389757f5c73

Contents?: true

Size: 1.61 KB

Versions: 52

Compression:

Stored size: 1.61 KB

Contents

#!/bin/sh
set -e

# Feel free to change any of the following variables for your app:
TIMEOUT=${TIMEOUT-60}
APP_ROOT=<%= current_path %>
PID_DIR=$APP_ROOT/tmp/pids
PID=$PID_DIR/unicorn.pid
CMD="cd $APP_ROOT;  bundle exec unicorn -D -c <%= "#{shared_path}/config/unicorn.rb" %> -E <%= fetch(:rails_env) %>"
AS_USER=deploy
set -u

OLD_PIN="$PID.oldbin"

sig () {
  test -s "$PID" && kill -$1 `cat $PID`
}

oldsig () {
  test -s $OLD_PIN && kill -$1 `cat $OLD_PIN`
}

workersig () {
  workerpid="$APP_ROOT/tmp/pids/unicorn.$2.pid"
  
  test -s "$workerpid" && kill -$1 `cat $workerpid`
}

run () {
  if [ "$(id -un)" = "$AS_USER" ]; then
    eval $1
  else
    su -c "$1" - $AS_USER
  fi
}

case "$1" in
start)
  sig 0 && echo >&2 "Already running" && exit 0
  run "$CMD"
  ;;
stop)
  sig QUIT && exit 0
  echo >&2 "Not running"
  ;;
force-stop)
  sig TERM && exit 0
  echo >&2 "Not running"
  ;;
kill_worker)
  workersig QUIT $2 && exit 0
  echo >&2 "Worker not running"
  ;;
restart|reload)
  sig USR2 && echo reloaded OK && exit 0
  echo >&2 "Couldn't reload, starting '$CMD' instead"
  run "$CMD"
  ;;
upgrade)
  if sig USR2 && sleep 2 && sig 0 && oldsig QUIT
  then
    n=$TIMEOUT
    while test -s $OLD_PIN && test $n -ge 0
    do
      printf '.' && sleep 1 && n=$(( $n - 1 ))
    done
    echo

    if test $n -lt 0 && test -s $OLD_PIN
    then
      echo >&2 "$OLD_PIN still exists after $TIMEOUT seconds"
      exit 1
    fi
    exit 0
  fi
  echo >&2 "Couldn't upgrade, starting '$CMD' instead"
  run "$CMD"
  ;;
reopen-logs)
  sig USR1
  ;;
*)
  echo >&2 "Usage: $0 <start|stop|restart|upgrade|force-stop|reopen-logs>"
  exit 1
  ;;
esac

Version data entries

52 entries across 52 versions & 3 rubygems

Version Path
teleporter-2.0.11 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-2.0.10 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
capistrano-cookbook-0.2.1 lib/capistrano/cookbook/templates/unicorn_init.sh.erb
teleporter-2.0.9 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-2.0.8 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-2.0.7 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-2.0.6 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-2.0.4 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-2.0.2 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-2.0.1 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-2.0.0 lib/generators/teleport/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-1.2.4 lib/generators/initial/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-1.2.3 lib/generators/initial/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-1.2.2 lib/generators/initial/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-1.2.1 lib/generators/initial/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-1.1.1 lib/generators/initial/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-1.1.0 lib/generators/initial/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-1.0.2 lib/generators/initial/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-1.0.1 lib/generators/initial/templates/capistrano/shared/unicorn_init.sh.erb
teleporter-1.0.0 lib/generators/initial/templates/capistrano/shared/unicorn_init.sh.erb